#include <Windows.h>
#include <stdio.h>
#include <stdlib.h>

void PrintErrorMessage(char *szFile, char *szFunction, int nLine);
void PrintUsage(void);
BOOL SetPrivilege(HANDLE hToken, LPCTSTR lpszPrivilege, BOOL bEnablePrivilege);

int main(int argc, char *argv[]) {

	BOOL bGet = FALSE;
	BOOL bSet = FALSE;
	BOOL bClear = FALSE;

	/* ̉ */
	{
		if ((argc != 2) && (argc != 4))
			PrintUsage();

		/* -G  -S tÕ`FbN */
		if (!strncmp(argv[1], "-S", 2))
			bSet = TRUE;
		else if (!strncmp(argv[1], "-G", 2))
			bGet = TRUE;
		else if (!strncmp(argv[1], "-C", 2))
			bClear = TRUE;
		else
			PrintUsage();
	}

	/* ݒl̎擾 */
	if (bGet) {
		SIZE_T MinimumFileCacheSize = 0;
		SIZE_T MaximumFileCacheSize = 0;
		DWORD dwFlags = 0;

		if (!GetSystemFileCacheSize(&MinimumFileCacheSize, &MaximumFileCacheSize, &dwFlags)) {
				PrintErrorMessage((__FILE__), "GetSystemFileCacheSize", __LINE__);
				ExitProcess(1);
		}
		printf("Success: GetSystemFileCacheSize(Min:[%lu], Max:[%lu], Flags: %d)\n", MinimumFileCacheSize, MaximumFileCacheSize, dwFlags);
	}

	/* SE_SHUTDOWN_NAME ̎擾 */
	if (bSet | bClear) {
		HANDLE hToken;
		/* vZXg[N̎擾 */
		if (!OpenProcessToken(GetCurrentProcess(), 
				TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken)) {
			PrintErrorMessage(__FILE__, "OpenProcessToken", __LINE__);
			ExitProcess(1);
		}
		/* SE_INCREASE_QUOTA_NAME ̎擾 */
		if (!SetPrivilege(hToken, SE_INCREASE_QUOTA_NAME, TRUE)) {
			CloseHandle(hToken);
			ExitProcess(1);
		}
		CloseHandle(hToken);
	}

	/* ~b^̃NA */
	if (bClear) {
		SIZE_T MinimumFileCacheSize = 0;
		SIZE_T MaximumFileCacheSize = 0;
		DWORD dwFlags = 0;

		/* ݒl擾ācc */
		if (!GetSystemFileCacheSize(&MinimumFileCacheSize, &MaximumFileCacheSize, &dwFlags)) {
				PrintErrorMessage((__FILE__), "GetSystemFileCacheSize", __LINE__);
				ExitProcess(1);
		}

		dwFlags = FILE_CACHE_MAX_HARD_DISABLE | FILE_CACHE_MIN_HARD_DISABLE;

		/* ݒl+tO~b^Ɏw肵Sets */
		if (!SetSystemFileCacheSize(MinimumFileCacheSize, MaximumFileCacheSize, dwFlags)) {
			PrintErrorMessage((__FILE__), "SetSystemFileCacheSize", __LINE__);
			ExitProcess(1);
		}
		printf("Success: SetSystemFileCacheSize(Min:[%lu], Max:[%lu], Flags: %d)\n", MinimumFileCacheSize, MaximumFileCacheSize, dwFlags);
	}

	/* ~b^̐ݒ菈 */
	if (bSet) {
		SIZE_T MinimumFileCacheSize = 0;
		SIZE_T MaximumFileCacheSize = 0;
		DWORD dwFlags = 0;

		/* ݒ肷l̎擾 */
		MinimumFileCacheSize = atoi(argv[2]);
		MaximumFileCacheSize = atoi(argv[3]);

		/* MBPʂɕϊ */
		MinimumFileCacheSize = MinimumFileCacheSize * 1024 * 1024;
		MaximumFileCacheSize = MaximumFileCacheSize * 1024 * 1024;

		/* tO̐ݒ */
		dwFlags = FILE_CACHE_MAX_HARD_ENABLE | FILE_CACHE_MIN_HARD_ENABLE;

		if (!SetSystemFileCacheSize(MinimumFileCacheSize, MaximumFileCacheSize, dwFlags)) {
			PrintErrorMessage((__FILE__), "SetSystemFileCacheSize", __LINE__);
			ExitProcess(1);
		}

		printf("Success: SetSystemFileCacheSize(Min:[%lu], Max:[%lu], Flags: %d)\n", MinimumFileCacheSize, MaximumFileCacheSize, dwFlags);
	}

	ExitProcess(0);
}

void PrintUsage() {
	printf("Usage: SystemFileCacheSize [-G|-C|-S minMB maxMB ]\n");
	printf("Call [GS]etSystemFileCacheSize()\n");
	printf("-G: Get, -C: Clear, -S: Set\n");

	ExitProcess(255);
}